﻿using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Stars
{
    class Button
    {
        public Texture2D tex;
        public Color color;
        public Vector2 pos;
        public Vector2 textPos;
        public SpriteFont font;
        public string text;
        
        private Color clr;
        private MousePressed button = new MousePressed();


        public Button(GraphicsDevice dev, Vector2 position, SpriteFont sFont, string s, Color clr, bool autoCenter = true, int size = -1)
        {
            if (size < 0) this.tex = Game.emptyTexture(15 * s.Length + 14, 22, clr, dev);
            else this.tex = Game.emptyTexture(size, 22, clr, dev);

            if (autoCenter) this.pos = new Vector2(position.X - tex.Width / 2, position.Y); // Auto-Center
            else this.pos = position;

            this.font = sFont;
            this.text = s;
            this.color = clr;
            this.clr = clr;
            this.textPos = new Vector2(pos.X + 2, pos.Y - 2);//new Vector2(pos.X + tex.Width / 4 - 7, pos.Y);
        }

        public bool update(Vector2 mousePos, bool isDown)
        {
            // Mouse is in button
            if (mousePos.X >= pos.X && mousePos.X <= pos.X + tex.Width && mousePos.Y >= pos.Y && mousePos.Y <= pos.Y + tex.Height)
            {
                // Leftmousebutton is down
                if (isDown) clr = Game.decreaseAllChannels(color, 101);
                else clr = Game.decreaseAllChannels(color, 50); // is not

                return button.pressed(isDown);
            }
            else
            {
                clr = color;
                button.pressed(false); // Reset it
            }
            return false;
        }

        public void draw(SpriteBatch sb)
        {
            sb.Draw(tex, pos, clr);
            sb.DrawString(font, text, textPos, Color.White);
        }
    }
}
