﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Stars
{
    class Camera
    {
        Viewport viewport;
        public Matrix transform;
        Vector2 center;

        public int xOffSet, yOffSet;

        public Camera(Viewport view, int width, int height)
        {
            this.viewport = view;
            this.xOffSet = width;
            this.yOffSet = height;
        }

        public void update(Vector2 pos)
        {
            if (pos.X < viewport.Width / 2)
                center.X = viewport.Width / 2;
            else if (pos.X > xOffSet - (viewport.Width / 2))
                center.X = xOffSet - (viewport.Width / 2);
            else
                center.X = pos.X;

            if (pos.Y < viewport.Height / 2)
                center.Y = viewport.Height / 2;
            else if (pos.Y > yOffSet - (viewport.Height / 2))
                center.Y = yOffSet - (viewport.Height / 2);
            else
                center.Y = pos.Y;

            transform = Matrix.CreateTranslation(new Vector3(-center.X + (viewport.Width / 2),
                -center.Y + (viewport.Height / 2), 0));
        }
    }
}
