﻿using System;
using System.IO;

namespace JDB
{
    public class DataBase
    {
        private string[][] lines;
        public string[][] Rows { get { return lines; } }
        
        private string[] l;
        public string[] Lines { get { return l; } }

        private string path;
        public string Path { get { return path; } }

        private string[] columns;
        public string[] Columns { get { return columns; } }

        private char splitChar;
        public char SplitCharacter { get { return splitChar; } }

        private char hookChar;
        public char HookCharacter { get { return hookChar; } }

        public DataBase(string dbpath, string[] data, char splitCharacter = ' ', char hookCharacter = '"')
        {
            this.path = Directory.GetCurrentDirectory() + "\\" + dbpath;
            this.columns = data;
            this.splitChar = splitCharacter;
            this.hookChar = hookCharacter;
            readFile();
        }

        public string getWriteString(string[] data)
        {
            if (data.Length != columns.Length) return null;

            int a = 0;
            string[] parts = new string[data.Length];

            for (int i = 0; i < data.Length; i++)
            {
                parts[a] = hookChar + data[i].Replace("" + hookChar, "#hookchar#").Replace(Environment.NewLine, "#nlchar#") + hookChar + splitChar;
                a++;
            }

            parts[a - 1] = parts[a - 1].Split(splitChar)[0]; // Our last problem, is now gone forever! Muahahahahah!

            string finalString = "";
            for (int i = 0; i < parts.Length; i++)
            {
                finalString += parts[i];
            }
            return finalString;
        }

        // Just for the lazy people like me
        public void add(object[] data)
        {
            string[] s = new string[data.Length];
            for (int i = 0; i < data.Length; i++)
            {
                s[i] = data[i].ToString();
            }
            add(s);
        }

        // Well this was once bigger.
        public void add(string[] data)
        {
            writeToDatabaseFile(getWriteString(data), true);
        }

        private void rem(int where)
        {
            for (int i = where + 1; i < lines.Length; i++)
            {
                lines[i - 1] = lines[i]; // lie
            }
            if (lines.Length > 0) Array.Resize(ref lines, lines.Length - 1);
        }

        // Refresh-like method
        public void writeToDatabaseFile(string extra = "", bool readAfterWrite = false)
        {
            checkFile();

            string readed = "";
            using (StreamReader read = new StreamReader(path)) readed = read.ReadToEnd();

            if (readed != "") readed += Environment.NewLine;
            using (StreamWriter write = new StreamWriter(path)) write.Write(readed + extra);

            if (readAfterWrite) readFile(); // Re-init and done!
        }

        public void add(string[] data, int where, bool rewrite = true)
        {
            Array.Resize(ref lines, lines.Length + 1);

            if (where < 0 || where >= lines.Length) return;

            if (lines.Length - 1 > 0)
            {
                for (int i = lines.Length - 2; i >= where; i--)
                {
                    lines[i + 1] = lines[i];
                    lines[i].GetLength(0);
                }
            }
            
            lines[where] = data;

            if (rewrite) rewriteDatabase();
        }


        public void rewriteDatabase()
        {
            string toWrite = "";
            for (int i = 0; i < lines.Length - 1; i++)
            {
                toWrite += getWriteString(lines[i]) + Environment.NewLine;
            }
            toWrite += getWriteString(lines[lines.Length - 1]);

            checkFile();
            using (StreamWriter write = new StreamWriter(path)) write.Write(toWrite);
        }

        public void remove(int where)
        {
            rem(where);
            rewriteDatabase();
        }

        public void remove(int[] data)
        {
            for (int i = 0; i < data.Length; i++) rem(data[i]);
            rewriteDatabase();
        }

        public void checkFile()
        {
            if (!File.Exists(path)) using (File.Create(path)) { }
        }

        public void readFile()
        {
            checkFile();

            using (StreamReader r = new StreamReader(path))
            {
                l = r.ReadToEnd().Split(new string[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);
            }

            lines = new string[l.Length][];

            for (int i = 0; i < lines.Length; i++)
            {
                lines[i] = getReadingString(l[i].Split(hookChar));
                l[i] = l[i];
            }
        }

        private string[] getReadingString(string[] data)
        {
            string[] toRet = new string[data.Length];
            try
            {
                int a = 0;
                for (int i = 1; i < data.Length; i += 2)
                {
                    toRet[a] = data[i].Replace("#hookchar#", hookChar.ToString()).Replace("#nlchar#", Environment.NewLine);
                    a++;
                }
                Array.Resize(ref toRet, a);
                return toRet;
            }
            catch // Will cause holes, so don't mess it up.
            {
                return null;
            }
        }
    }
}
