﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Stars
{
    class FlashingSprite
    {
        public Texture2D tex;
        public Vector2 pos;
        public Color clr;

        Channel d, u, c, k; // But hey, I can spell words! Ode to http://ducksarethebest.com !


        public FlashingSprite(GraphicsDevice device, Color color, int width, int height, Vector2 position, byte intensity = 1)
        {
            this.clr = color;
            this.pos = position;

            reset(intensity);

            this.tex = Game.emptyTexture(width, height, clr, device);
        }

        public void reset(byte intensity)
        {
            d = new Channel(intensity);
            u = new Channel(intensity);
            c = new Channel(intensity);
            k = new Channel(intensity);
        }

        public void update()
        {
            // This is not very efficient I realize. What if you don't even have a green channel?! I knew I couldn't thrust the duck! :(
            clr.R = d.affectChannel(clr.R);
            clr.G = u.affectChannel(clr.G);
            clr.B = c.affectChannel(clr.B);
            clr.A = k.affectChannel(clr.A);
        }

        public void draw(SpriteBatch sb)
        {
            sb.Draw(tex, pos, clr);
        }

        public struct Channel
        {
            public byte increase;
            public int increaser;

            public Channel(byte intensity)
            {
                this.increase = intensity;
                this.increaser = increase;
            }            

            public byte affectChannel(byte channel)
            {
                int him = channel;
                him += increaser;

                if (him >= 255)
                {
                    increaser = -increase;
                    him = 255;
                }
                else if (him <= 0)
                {
                    increaser = increase;
                    him = 0;
                }

                return (byte)him;
            }
        }
    }
}
