﻿using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Stars
{
    class Log
    {
        public Vector2 pos;
        public Color color;
        public SpriteFont font;

        public float defTime;

        float time = 0f;
        string logMsg;
        bool drawIt = false;


        public Log(Color clr, Vector2 defaultPos, SpriteFont sfont, float defaultTime = 3000)
        {
            this.pos = defaultPos;
            this.color = clr;
            this.font = sfont;
            this.defTime = defaultTime;
        }

        public void log(string msg)
        {
            this.time = 0f;
            this.logMsg = msg;
            drawIt = true;
        }

        public void update(GameTime gt)
        {
            if (drawIt)
            {
                time += gt.ElapsedGameTime.Milliseconds;
                if (time >= defTime) drawIt = false;
            }
        }        

        public void draw(SpriteBatch sb)
        {
            if (drawIt) sb.DrawString(font, logMsg, pos, color);
        }
    }
}
