﻿using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Stars
{
    class PlayerTarget
    {
        public const float maxVel = .2f;
        public Texture2D tex;
        public Vector2 pos;
        public bool acomplished = false;

        public PlayerTarget(Texture2D texture)
        {
            this.tex = texture;

            Random ran = new Random(Guid.NewGuid().GetHashCode());
            this.pos = new Vector2(ran.Next(Game.map.Width - tex.Width), ran.Next(Game.map.Height - tex.Height));
        }

        public void update(Player p)
        {
            if (pos.X + tex.Width > p.pos.X && pos.X < p.pos.X + p.tex.Width && pos.Y + tex.Height > p.pos.Y && pos.Y < p.pos.Y + p.tex.Width &&
                p.vel.X > -maxVel && p.vel.X < maxVel && p.vel.Y > -maxVel && p.vel.Y < maxVel)
            {
                acomplished = true;
            }
        }

        public void draw(SpriteBatch sb)
        {
            sb.Draw(tex, pos, Color.White);
        }
    }
}
