﻿using System;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;

namespace Stars
{
    class StarSystem
    {
        public Snow[] snow;
        public Vector2 pos;// = new Vector2(200, 105);

        public StarSystem(Texture2D tex, Color clr, Vector2 rotpos, int length = 200)
        {
            snow = new Snow[length];
            this.pos = rotpos;

            for (int i = 0; i < snow.Length; i++)
            {
                snow[i] = new Snow(tex, clr);
            }
        }

        public void changeColors(Color clr)
        {
            Random ran = new Random();
            for (int i = 0; i < snow.Length; i++)
            {
                ran = new Random(ran.Next(int.MaxValue));
                snow[i].clr = new Color(ran.Next(clr.R + 1), ran.Next(clr.G + 1), ran.Next(clr.B + 1));
            }
        }

        public void update()
        {
            for (int i = 0; i < snow.Length; i++) snow[i].update(pos);
        }

        public void draw(SpriteBatch sb)
        {
            for (int i = 0; i < snow.Length; i++) snow[i].draw(sb);
        }
    }

    // I meant stars, anyway.
    class Snow
    {
        // this.clr = new Color(ran.Next(210), ran.Next(100), ran.Next(100));
        public Vector2 pos;
        Texture2D tex;
        public Color clr;

        public float rot;
        public float posRot;
        public float rotStep;
        public float zoom;

        public Snow(Texture2D texture, Color clr)
        {
            this.tex = texture;

            Random ran = new Random(Guid.NewGuid().GetHashCode());
            this.rot = (float)Math.PI * ran.Next(361) / 180;
            this.posRot = (float)Math.PI * ran.Next(361) / 180;
            this.rotStep = (float)(ran.Next(20, 300) / 10) / 50 / 10 / 4;
            this.clr = new Color(ran.Next(clr.R + 1), ran.Next(clr.G + 1), ran.Next(clr.B + 1)); // G AND RED MUST BE HEIGH
            this.pos = new Vector2(
                ran.Next(Game.screenWidth - tex.Width),
                ran.Next(Game.screenHeight - tex.Height));
            this.zoom = (float)(ran.Next(6, 11)) / 10;
        }

        public void update(Vector2 center)
        {
            rot += rotStep;
            posRot += Game.rotateSpeed;
            this.pos = rotate(posRot, pos, center);
        }

        // Thanks google!
        public static Vector2 rotate(float angle, Vector2 currentPos, Vector2 centre)
        {
            double distance = Math.Sqrt(Math.Pow(currentPos.X - centre.X, 2) + Math.Pow(currentPos.Y - centre.Y, 2));
            return new Vector2((float)(distance * Math.Cos(angle)), (float)(distance * Math.Sin(angle))) + centre;
        }

        public void draw(SpriteBatch sb)
        {
            sb.Draw(tex, pos, null, clr, rot, new Vector2(tex.Width / 4, tex.Height / 2), zoom, SpriteEffects.None, 0);
        }
    }
}
